/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

//DECLARACION DE CLASES
function Jugador (name,x,y){ 
	//Propiedades
	
	//Nombre
	this.nombre=name;
	
	//Cuerpo
	this.cuerpo_img=new Array();
	this.cuerpo_img[0]=new Image();
	this.cuerpo_img[0].src = URL_IMAGENES+"bodys/cuerpo.png";
	this.cuerpo_width=25*ESCALA_GENERAL;
	this.cuerpo_height=35*ESCALA_GENERAL;
	this.x=x;
	this.y=y;
	this.xref=Math.round(this.cuerpo_width/2);
	this.yref=Math.round(this.cuerpo_height);
	
	//Cara
	this.cara_img=new Image();
	this.cara_img.src=URL_IMAGENES+"faces/"+name+".jpg";
	this.cara_xref={{ appearance.face_x }}*ESCALA_GENERAL; //x respecto al cuerpo
	this.cara_yref={{ appearance.face_y }}*ESCALA_GENERAL; //y respecto al cuerpo
	this.cara_w={{ appearance.face_w }}*ESCALA_GENERAL;
	this.cara_h={{ appearance.face_h }}*ESCALA_GENERAL;
	
	//Metodos
	this.getX=function(){return this.x+this.xref;}
	this.getY=function(){return this.y+this.yref;}
	this.getXCara=function(){return this.x+this.cara_xref;}
	this.getYCara=function(){return this.y+this.cara_yref;}
}

function Bandas (){

	var n_bandas={{ datos_bandas|length }};
	this.bandas=new Array(n_bandas);
	var nombres=new Array();
	
	{% for banda in bandas %}
		nombres[nombres.length]="{{ banda }}";
	{% endfor %}

	var datos_bandas=new Array();
	
	{% for datos_banda in datos_bandas %}
		var datos_banda=new Array();
		{% for dato in datos_banda %}
			datos_banda[datos_banda.length]="{{ dato }}";
		{% endfor %}
		datos_bandas[datos_bandas.length]=datos_banda;
	{% endfor %}
	
	//Repartimos los elementos por la pantalla
	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,ALTURA_VENTANA/2,n_bandas,3,200,100,MARGEN_ENTRE_BANDAS);

	var i;
	for(i=0;i<n_bandas;i++){
		this.bandas[i]=new Banda(datos_bandas[i],coordenadas[i][0],coordenadas[i][1]);
	}
	
	this.banda_destacada=-1;
	
	//Opciones para cada banda
	this.opciones=new Array(2);
	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,CENTRAR_BANDA_Y+150,this.opciones.length,5,50,50,20);
	this.opciones[0]=new Boton("boton_nuevomiembro",coordenadas[0][0],coordenadas[0][1],50,50);
	this.opciones[1]=new Boton("boton_volverabandas",coordenadas[1][0],coordenadas[1][1],50,50);
	this.opcion_destacada=-1;
}

function Banda (datos,x,y){
	this.name=new Texto(datos[0],x+73,y+50,100,75,5,20,AL_CEN);
	var coordenadas_members=repartir_elementos(ANCHURA_VENTANA/2,3*ALTURA_VENTANA/4,datos.length-1,10,100,200,50);
	this.members=new Array(datos.length-1);
	this.opciones=new Array(datos.length-1);
	this.opcion_destacada=-1;
	for(i=1;i<datos.length;i++){
		this.members[i-1]=new Jugador(datos[i],coordenadas_members[i-1][0],coordenadas_members[i-1][1]);
		this.opciones[i-1]=new Boton("boton_cerrar",this.members[i-1].x+100,this.members[i-1].y+100,30,30);
	}
	this.x_orig=x;
	this.y_orig=y;
	this.x=x;
	this.y=y;
	this.escala=0;
	this.velocidad_crecer=0.05;
	this.velocidad_x=0.05;
	this.velocidad_y=0.05;
	this.alpha=1.0;
	
	this.lanzar=0;
	this.crecer=1;
	this.show_text=0
	this.centrar=0;
	this.desvanecer=0;
	this.descentrar=0;
}

function Grid (){
	this.imagen=new Image();
	this.imagen.src=URL_IMAGENES+"scenarios/fondo_bandas.jpg";
	
	this.grid=new Array(GRID_ROWS);
	
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		this.grid[i]=new Array(GRID_COLUMNS);
		for(j=0;j<GRID_COLUMNS;j++)
			this.grid[i][j]=1;
	}
}

function Boton(url,x,y,w,h){
    this.image=new Image();
    this.image.src=URL_IMAGENES+"interface/"+url+".png";
    this.over_image=new Image();
    this.over_image.src=URL_IMAGENES+"interface/"+url+"2.png";
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
}

function Menu(w,h){
    this.botones=new Array(2);
    this.width=w*ESCALA_GENERAL;
    this.height=h*ESCALA_GENERAL;
    this.y=0;
    
    this.estado=0;

	var coordenadas=repartir_elementos(ANCHURA_VENTANA/2,50,this.botones.length,99,w,h,20);
    this.botones[0]=new Boton("boton_habitacion",coordenadas[0][0],this.y,w,h);
    this.botones[1]=new Boton("boton_logout",coordenadas[1][0],this.y,w,h);
}



function Texto(texto,x,y,w,h,m_x,m_y,al){

	var separadas=separar_palabras(texto);
	this.repartidas=repartir_texto(separadas,w);
	this.coordenadas=new Array(this.repartidas.length);
	
	var i;
	var y_linea=y-(this.repartidas.length*7.5);
	
	for(i=0;i<this.repartidas.length;i++){
		this.coordenadas[i]=new Array(2);
		if(al==AL_IZQ){
			this.coordenadas[i][0]=x-w/2;
		}else if(al==AL_DER){
			this.coordenadas[i][0]=x+w/2-contexto.measureText(this.repartidas[i]).width;
		}else if(al==AL_CEN){
			var linea_w=contexto.measureText(this.repartidas[i]).width;
			this.coordenadas[i][0]=x-linea_w/2;
		}
		this.coordenadas[i][1]=y_linea;
		y_linea+=m_y;
	}

	this.dibujar=function(x,y){
		var x_aux=x,y_aux=y;
		for(i=0;i<this.repartidas.length;i++){
			if(x==0) x_aux=this.coordenadas[i][0];
			if(y==0) y_aux=this.coordenadas[i][1];			
			contexto.fillText(this.repartidas[i], x_aux, y_aux);
			y_aux+=25;
		}
	}
	
	this.obtener_texto=function(){
		var entero="";
		for(i=0;i<this.repartidas.length;i++){
			entero+=this.repartidas[i];
		}
		return entero;
	}
}

function Dialogo(x,y,w,h,tag){
	
	this.tag=tag;
	if(tag!=-1){
		this.x=x;
		this.y=y;
		this.w=w;
		this.h=h;
		this.alpha=0.0;
		this.opcion_apuntada=-1;
		this.opcion_w=100;
		this.opcion_h=50;
		this.coordenadas_opciones=repartir_elementos(ANCHURA_VENTANA/2,y+h-h/3,2,2,this.opcion_w,this.opcion_h,50);
		
		this.destacar_opciones=function(x,y){
			this.opcion_apuntada=-1;
			var i;
			for(i=0;i<this.coordenadas_opciones.length && this.opcion_apuntada==-1;i++){
				var x1=this.coordenadas_opciones[i][0];
				var y1=this.coordenadas_opciones[i][1];
				var x2=x1+this.opcion_w;
				var y2=y1+this.opcion_h;

				if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
					this.opcion_apuntada=i;
			}			
		}
	}	
}