/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	down=0;
	down_time=0;
	
	//Inicializamos el escenario
	grid=new Grid();
	//Inicializamos las bandas
	bandas=new Bandas();
	banda_centrada=0;
	
	//Creamos el menu
	menu=new Menu(50,50);
	menu_button_pointed=-1;
	
	//Inicializamos el dialogo
	dialogo=new Dialogo(0,0,0,0,-1);
	
	//Progreso de la carga
	var total=4+menu.botones.length*2;
	trozo=100/total;
	progreso=1;
	for(i=0;i<menu.botones.length;i++){
		menu.botones[i].image.onload = function() {progreso+=trozo;}
		menu.botones[i].over_image.onload = function() {progreso+=trozo;}
	}
	grid.imagen.onload = function() {
		progreso+=trozo;
		tam_image_square_x=grid.imagen.width/GRID_COLUMNS;
		tam_image_square_y=grid.imagen.height/GRID_ROWS;
	}
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){	
	
	//Menu
	if(menu.estado==DESPLEGAR_MENU){
        if(menu.y<MAX_MENU_HIGHT)   menu.y++;
    }else if(menu.estado==REPLEGAR_MENU){
        if(menu.y>0){
            menu.y--;
        }else{
            menu.estado=MENU_INACTIVO;
			//Marcamos las casillas para no redibujarlas
			dibujar_fondo();
        }
    }
	
	//Tiempo que el raton se mantiene presionado
	if(down && down_time<MAX_DOWN_TIME){
		down_time++;
	}
	
	//
	for(i=0;i<bandas.bandas.length;i++){
		//Lanzar las bandas
		if(bandas.bandas[i].lanzar){
			if(bandas.bandas[i].crecer){
				bandas.bandas[i].escala+=bandas.bandas[i].velocidad_crecer;
				bandas.bandas[i].velocidad_crecer+=0.01;
				if(bandas.bandas[i].escala>=ESCALA_MAX_BANDAS){
					bandas.bandas[i].crecer=0;
					bandas.bandas[i].velocidad_crecer=0.02;
				}
			}else if(!bandas.bandas[i].crecer){
				if(bandas.bandas[i].escala>1){
					bandas.bandas[i].escala-=bandas.bandas[i].velocidad_crecer;
				}else{
					bandas.bandas[i].show_text=1;
					bandas.bandas[i].lanzar=0;
				}
			}
		}else if(bandas.bandas[i].centrar){ //Centramos la banda clickeada
			var distancia_x=Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x);
			bandas.bandas[i].velocidad_x=distancia_x/Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x_orig)*20;

			if(bandas.bandas[i].x<CENTRAR_BANDA_X){
				bandas.bandas[i].x+=bandas.bandas[i].velocidad_x;
			}else if(bandas.bandas[i].x>CENTRAR_BANDA_X){
				bandas.bandas[i].x-=bandas.bandas[i].velocidad_x;
			}			
			
			var distancia_y=Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y);
			bandas.bandas[i].velocidad_y=distancia_y/Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y_orig)*20;

			if(bandas.bandas[i].y<CENTRAR_BANDA_Y){
				bandas.bandas[i].y+=bandas.bandas[i].velocidad_y;
			}else if(bandas.bandas[i].y>CENTRAR_BANDA_Y){
				bandas.bandas[i].y-=bandas.bandas[i].velocidad_y;
			}
		}else if(bandas.bandas[i].descentrar){ //Descentramos la banda clickeada
			var distancia_x=Math.abs(bandas.bandas[i].x_orig-bandas.bandas[i].x);
			bandas.bandas[i].velocidad_x=distancia_x/Math.abs(CENTRAR_BANDA_X-bandas.bandas[i].x_orig)*20;
			
			if(bandas.bandas[i].x<bandas.bandas[i].x_orig){
				bandas.bandas[i].x+=bandas.bandas[i].velocidad_x;
			}else if(bandas.bandas[i].x>bandas.bandas[i].x_orig){
				bandas.bandas[i].x-=bandas.bandas[i].velocidad_x;
			}	
			
			var distancia_y=Math.abs(bandas.bandas[i].y_orig-bandas.bandas[i].y);
			bandas.bandas[i].velocidad_y=distancia_y/Math.abs(CENTRAR_BANDA_Y-bandas.bandas[i].y_orig)*20;

			if(bandas.bandas[i].y<bandas.bandas[i].y_orig){
				bandas.bandas[i].y+=bandas.bandas[i].velocidad_y;
			}else if(bandas.bandas[i].y>bandas.bandas[i].y_orig){
				bandas.bandas[i].y-=bandas.bandas[i].velocidad_y;
			}
		}
		
		if(bandas.bandas[i].desvanecer && bandas.bandas[i].alpha>0){
			bandas.bandas[i].alpha-=0.1;
		}else if(!bandas.bandas[i].desvanecer && bandas.bandas[i].alpha<1.0){
			bandas.bandas[i].alpha+=0.1;
		}
	}
}

function dibujar() {

	/*if(progreso<100){
		draw_progressbar();
	}else{*/

		dibujar_fondo();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		dibujar_bandas();
		
		dibujar_dialogo();
		dibujar_menu();
		
		draw_fadein();
		draw_fadeout();
	//}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function lanzar_bandas(){
	for(i=0;i<bandas.bandas.length;i++)
		bandas.bandas[i].lanzar=1;
}

function destacar_botones_menu(x,y){
	menu_button_pointed=-1;
	var i;
	for(i=0;i<menu.botones.length && menu_button_pointed==-1;i++){
		var x1=menu.botones[i].x;
		var y1=menu.y;
		var x2=x1+menu.botones[i].w;
		var y2=y1+menu.botones[i].h;

		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
				menu_button_pointed=i;
	}
}

function destacar_bandas(x,y){
	bandas.banda_destacada=-1;
	for(i=0;i<bandas.bandas.length && bandas.banda_destacada==-1;i++){
		var x1=bandas.bandas[i].x;
		var y1=bandas.bandas[i].y;
		var x2=x1+200;
		var y2=y1+100;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.banda_destacada=i;
	}
}

function destacar_opciones_banda(x,y){
	bandas.opcion_destacada=-1;
	for(i=0;i<bandas.opciones.length && bandas.opcion_destacada==-1;i++){
		var x1=bandas.opciones[i].x;
		var y1=bandas.opciones[i].y;
		var x2=x1+bandas.opciones[i].w;
		var y2=y1+bandas.opciones[i].h;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.opcion_destacada=i;
	}
}

function destacar_opciones_miembro(x,y){
	bandas.bandas[bandas.banda_destacada].opcion_destacada=-1;
	for(i=0;i<bandas.bandas[bandas.banda_destacada].opciones.length && bandas.bandas[bandas.banda_destacada].opcion_destacada==-1;i++){
		var x1=bandas.bandas[bandas.banda_destacada].opciones[i].x;
		var y1=bandas.bandas[bandas.banda_destacada].opciones[i].y;
		var x2=x1+bandas.bandas[bandas.banda_destacada].opciones[i].w;
		var y2=y1+bandas.bandas[bandas.banda_destacada].opciones[i].h;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			bandas.bandas[bandas.banda_destacada].opcion_destacada=i;
	}
}

function repartir_elementos(x,y,n,c,w,h,m){
	var coordenadas=new Array(n);	
	var n_filas=Math.floor(n/c)+(n%c!=0);
	var tam_columna=n_filas*h+(n_filas-1)*m;
	var y_fila=y-tam_columna/2;
	
	var i=0;
	while(i<n){
		var tanda=n-i;
		if(tanda>3)tanda=3;
		var tam_fila=tanda*w+(tanda-1)*m;
		var x_fila=x-tam_fila/2;
		for(j=0;j<tanda;j++){
			coordenadas[i+j]=new Array(2);
			coordenadas[i+j][0]=x_fila;
			coordenadas[i+j][1]=y_fila;
			x_fila+=w+m;
		}
		y_fila+=h+m;
		i+=3;
	}
	
	return coordenadas;
}

function adaptar_x_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetX-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;        
    }
    
    else return -1; //Error    
}

function adaptar_y_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerY-20;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetY-20;        
    }
    
    else return -1; //Error    
}

function clean_grid(c1,r1,c2,r2){			
	for(i=r1;i<=r2;i++)
		for(j=c1;j<=c2;j++)
			grid.grid[i][j]=0;
}

function mark_grid(c1,r1,c2,r2){			
	for(i=r1;i<=r2;i++)
		for(j=c1;j<=c2;j++)
			grid.grid[i][j]=1;
}

function lanzar_dialogo(x,y,tag){
	dialogo=new Dialogo(x,y,300,200,tag);
	//mark_grid(6,1,GRID_COLUMNS-1,5);
}

function separar_palabras(texto){
	var separadas=new Array();
	var i;
	var palabra="";
	for(i=0;i<texto.length;i++){
		if(texto[i]!=" "){
			palabra=palabra+texto[i];
		}else{
			separadas[separadas.length]=palabra;
			palabra="";
		}
	}
	separadas[separadas.length]=palabra;
	
	return separadas;
}

function repartir_texto(palabras,w){
	var i=0;
	var lineas=new Array();
	
	while(i<palabras.length){
		var nueva_linea=palabras[i];
		i++;
		while(i<palabras.length && contexto.measureText(nueva_linea+" "+palabras[i]).width<w){
			nueva_linea=nueva_linea+" "+palabras[i];
			i++;
		}
		lineas[lineas.length]=nueva_linea;
	}
	
	return lineas;
}

function dibujar_texto(texto,x_ini,y_ini,w,h,m_x,m_y,al){
	
	var separadas=separar_palabras(texto);
	var repartidas=repartir_texto(separadas,w);
	
	if(al==AL_IZQ){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			contexto.fillText(repartidas[i], x_ini, y);
			y+=m_y;
		}
	}else if(al==AL_DER){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			var x=x_ini+w-contexto.measureText(repartidas[i]).width;
			contexto.fillText(repartidas[i], x, y);
			y+=m_y;
		}
	}else if(al==AL_CEN){
		var i;
		var y=y_ini+15;
		for(i=0;i<repartidas.length;i++){
			var linea_w=contexto.measureText(repartidas[i]).width;
			var x=x_ini+w/2-linea_w/2;
			contexto.fillText(repartidas[i], x, y);
			y+=m_y;
		}
	}
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}

function redireccionar(url){location.href=url;}